-- UniRemover.ms
-- By Nikolay Litvinov (gniklit@gmail.com)
-- Created On:	2013-11-02
-- Modified:	2017-10-07
-- tested using Max 2016
messageBox "Category: \"Niklit Scripts\""
macroScript uniremover Category:"Niklit Scripts" Tooltip:"UniRemover"
(

------------------------FUNCTIONS------------------------------


universal=null
global s1, directRotation_forfix
if selection.count == 1 do s1=selection[1]
Verts_not2e=#{}
Verts_2e=#{}
struct polyFns
	(
		fn RemoveVertex fco=fco.Remove selLevel:#Vertex,
		fn RemoveEdge fco=fco.Remove selLevel:#Edge,
		fn DeSelectionVert node_i fco=fco.SetSelection #Vertex #{},
		fn SetSelectionVert node_i fco Verts=fco.SetSelection #Vertex Verts,
		fn GetSelectionEdge fco node_i =fco.getselection #edge,
		fn RemoveIsoVerts fco = fco.deleteIsoVerts(),
		fn GetEdgeVertex fco EAr v node_i = fco.GetEdgeVertex EAr v,
		fn GetVertexEdgeCount fco VAr node_i =	fco.GetVertexEdgeCount VAr
	)
struct polyMODFns
	(
		fn RemoveVertex fco=fco.buttonop #RemoveVertex,
		fn RemoveEdge fco=fco.buttonop #RemoveEdge,
		fn DeSelectionVert node_i fco=setVertSelection node_i fco #{} keep:off,
		fn SetSelectionVert node_i fco Verts=(setVertSelection node_i fco #{} keep:off; setVertSelection node_i fco Verts keep:on),
		fn GetSelectionEdge fco node_i=fco.getselection #edge node: node_i,
		fn RemoveIsoVerts fco = fco.ButtonOp #RemoveIsoVerts,
		fn GetEdgeVertex fco EAr v node_i = fco.GetEdgeVertex EAr v node: node_i,
		fn GetVertexEdgeCount fco VAr node_i =	fco.GetVertexEdgeCount VAr node: node_i
	)

	fn tryInit fco =
		case classOf fco of
		(
			Editable_Poly: (universal = polyFns(); "Editable_Poly")
			Edit_Poly: (universal = polyMODFns(); "Edit_Poly")
			--default: (messageBox "This script only works with Edit/Editable_Poly objects."; false)
		)

fn sendkeys_CtrlRemove_fn=(
vbsPath = (GetDir #scripts) + "\\ctrl+BS.vbs"
shellLaunch "explorer.exe" vbsPath
)


fn EdgeRemove_fn fco=(
edgesel = try  fco.GetSelection #Edge catch polyOp.getEdgeSelection $
VuE=#()
for i in edgesel do (appendIfUnique VuE (polyop.getEdgeVerts $ i)[1]; appendIfUnique VuE (polyop.getEdgeVerts $ i)[2])
VuE
try fco.ButtonOp #RemoveEdge catch $.Remove selLevel:#Edge
		try case classof fco of
		(
		Editable_Poly: (polyop.setVertSelection $ (for i  in VuE where (((polyop.getEdgesUsingVert $ i)as array).count == 2) collect i); $.Remove selLevel:#Vertex)
		Edit_Poly: (fco.SetSelection #Vertex #{}; subObjectLevel=1; fco.Select #Vertex ((for i  in VuE where fco.GetVertexEdgeCount i == 2 collect i) as BitArray); fco.SetOperation #RemoveVertex; fco.Commit (); subObjectLevel=2)
		)
		catch()
)

fn RemoveVertex_fn fco=
case classof fco of
(
	Edit_Poly: (fco.ButtonOp #RemoveVertex)
Editable_Poly: (
	vrt=fco.getselection #Vertex
	if vrt.numberset==1 then universal.RemoveVertex fco
	else (
			fco.ConvertSelectionToBorder #Vertex #Edge
			edg=polyop.getEdgeSelection $
			if edg.isEmpty then universal.RemoveVertex fco else (fco.setselection #Edge edg; EdgeRemove_fn fco)
	     )
	)
)

fn NumV_fn fco = fco.GetNumVertices()
fn PushPrVertSel_fn fco =(PushPrompt ((((fco.getSelection #Vertex).numberset) as String) + " Vertex selected"))
fn Verts_2E_fn fco = (
	arV=(getVertSelection selection[1].mesh)
	if arV.numberset==0 do
	for i=1 to selection.count do
	(
		allVerts=#{1..selection[1].numverts}
		Verts_2e = (for v in allVerts where (universal.GetVertexEdgeCount fco v selection[1])==2 collect v) as BitArray
		OpenE=#()
		openEdges.Check currentTime selection[1] &OpenE
		OpenVert=(for e in OpenE collect universal.GetEdgeVertex fco e 1 selection[1]) as BitArray
			if OpenVert.numberset==0
			then universal.SetSelectionVert selection[1] fco Verts_2e
			else
			(
				FiltOpenV = Verts_2e-OpenVert
				universal.SetSelectionVert selection[1] fco FiltOpenV
			)
	)
)

fn epSO_1_fn fco =
(numV0=NumV_fn fco
VertAr=for i in selection collect (getVertSelection i.mesh) as Array

	for i=1 to VertAr.count do 
	if VertAr[i].count==0
	then (universal.RemoveIsoVerts fco
			Verts_2E_fn fco
			PushPrVertSel_fn fco)
	else RemoveVertex_fn fco
	numV2=NumV_fn fco
	differV=numV0-numV2
	if differV > 0 do PushPrompt (differV as string + " Vertex removed")
)

fn smoothRemove_fn=
(
edg=polyop.getEdgeSelection $
$.GrowSelection ()
edgGrow=polyop.getEdgeSelection $
edg_ext=edgGrow-edg
$.setselection #edge edg_ext
$.connectEdgeSegments = 2
$.connectEdgeSlide = 0
$.EditablePoly.ConnectEdges ()
$.connectEdgeSegments = 1
$.setselection #edge edg
macros.run "PolyTools" "GrowLoop"
edgLoop1=polyop.getEdgeSelection $
$.setselection #edge edg
$.setRingShift 2 true false
$.EditablePoly.SelectEdgeLoop ()
edgShift2=polyop.getEdgeSelection $
$.setselection #edge (edgShift2+edgLoop1)
sendkeys_CtrlRemove_fn()
)

fn epSO_2_fn=(
if keyboard.escPressed then smoothRemove_fn()
else
(
gco=modPanel.getCurrentObject()
if (polyop.getEdgeSelection $).numberset==(polyop.getEdgeSelection $).count
then PolyToolsModeling.Quadrify off off
else sendkeys_CtrlRemove_fn()
)
)

fn isEmpty_KNspl_fn=(
numspl=(for i=1 to numSplines $ collect i).count
isEmpty_kn=(for i=1 to numspl where ((getKnotSelection $ i)as BitArray).isEmpty collect on).count
isEmpty_kn==numspl)

fn DOTselKnots_fn=
(
if subobjectlevel!=1 do subobjectlevel=1
global DOTknotSel_fn, getKnotSelection_ar, numSplines_ar
numSplines_ar=for i=1 to numSplines $ collect i
fn getKnotSelection_ar_fn=(getKnotSelection_ar=for i=1 to numSplines_ar.count collect (getKnotSelection $ i)as BitArray)
getKnotSelection_ar_fn()
isEmptyKnots=for i=1 to getKnotSelection_ar.count where not getKnotSelection_ar[i].isEmpty collect i

	fn DOTknotSel_fn=(
		DOTselKnots=
		(
		for spl=1 to numSplines_ar.count collect
		(for i=numKnots $ spl to 1 by -2 collect i) as BitArray
		)
		setKnotSelection_ar=for i=1 to numSplines_ar.count collect (getKnotSelection_ar[i]*DOTselKnots[i]) as Array
		for i=1 to numSplines_ar.count do
		setKnotSelection $ numSplines_ar[i] setKnotSelection_ar[i] keep: off
		)
if isEmptyKnots[1]==undefined then (max select all; getKnotSelection_ar_fn(); DOTknotSel_fn()) else DOTknotSel_fn()
)


fn RemSpl_fn fco = (
	if classof fco != Edit_Spline then fco = $
	if (subobjectLevel<3 and subobjectLevel != 0)
	then actionMan.executeAction 0 "40020"/*Delete Objects*/ else splineOps.startTrim fco
	)


fn SetVertOpen_2e_fn fco =(
OpenE=#()
openEdges.Check currentTime selection[1] &OpenE
allOpnVert=for e in OpenE collect fco.GetEdgeVertex e 1
Verts_2e = (for v  in allOpnVert where fco.GetVertexEdgeCount v == 2 collect v) as BitArray
subObjectLevel=1
universal.SetSelectionVert selection[1] fco Verts_2e
)



fn xFixShapeX_fn fco =
	(fco.pivot=fco.center
	case directRotation_forfix of
		(
	undefined: (rotate fco (angleaxis 270 [0,1,0]); ResetXForm fco; collapseStack fco; rotate fco (angleaxis -270 [0,1,0]); directRotation_forfix=true)
	true: (rotate fco (angleaxis 90 [0,1,0]); ResetXForm fco; collapseStack fco; rotate fco (angleaxis -90 [0,1,0]); directRotation_forfix=undefined)
		)
	)
fn yFixShapeX_fn fco =
	(fco.pivot=fco.center
	case directRotation_forfix of
		(
		undefined: (rotate fco (angleaxis 270 [1,0,0]); ResetXForm fco; collapseStack fco; rotate fco (angleaxis -270 [1,0,0]); directRotation_forfix=true)
		true: (rotate fco (angleaxis 90 [1,0,0]); ResetXForm fco; collapseStack fco; rotate fco (angleaxis -90 [1,0,0]); directRotation_forfix=undefined)
		)
	)
fn zFixShapeX_fn fco =
	(fco.pivot=fco.center
	ResetXForm fco; collapseStack fco
	)

fn fixShapeXform_fn fco = (
	with redraw off
	(
		BBo=nodeGetBoundingBox fco (matrix3 1)
		xBB=BBo[2].x-BBo[1].x
		yBB=BBo[2].y-BBo[1].y
		zBB=BBo[2].z-BBo[1].z

		xOrder=(xBB<yBB and xBB<zBB)
		yOrder=(yBB<xBB and yBB<zBB)
		zOrder=(zBB<xBB and zBB<yBB)

		case of
		(
		xOrder: xFixShapeX_fn fco
		yOrder: yFixShapeX_fn fco
		zOrder: zFixShapeX_fn fco
		)
	)
)


fn FaceReduce_fn fnO =(
with Redraw off
	(
	case classof fnO of
		(
Editable_Poly: (fnO.tesselateBy = 1
				fnO.tessellate #Face)
	Edit_Poly: (fnO.tessellateByFace = 1
				fnO. SetOperation #Tessellate
				fnO.Commit ())
		)
fnO.ConvertSelectionToBorder #Face #Edge
fnO.SetSelection #Face #{}
	case classof fnO of
		(
Editable_Poly: EdgeRemove_fn fco
	Edit_Poly: EdgeRemove_fn fco
		)
	)
)

fn SO4_op_fn fco=(
F0=(fco.getSelection #Face) as array
if F0.count>0
then
	if keyboard.escPressed 
	then FaceReduce_fn fco
	else (
			F0=(fco.getSelection #Face) as array
			EuF=polyop.getEdgesUsingFace $ F0
			fco.SetSelection #Edge EuF
		  	EdgeRemove_fn fco
		  --try fco.Remove selLevel:#Edge flag:1 catch fco.ButtonOp #RemoveEdge
	     )
else
(
   deg = 60  /* defines the max angleDiff to straight up for selection */
   with undo on
	for Obj in selection as array where isValidNode Obj AND superclassOf Obj == geometryClass do
	polyop.setFaceSelection Obj  ((for f = 1 to Obj.numFaces collect (if acos (dot (polyOp.getFaceNormal Obj f node:Obj) (inverse(getViewTM())).row3) < deg /*OR acos (dot (polyOp.getFaceNormal Obj f node:Obj) -(inverse(getViewTM())).row3) < deg*/  then f else 1)) as bitArray) 
   completeRedraw()
)
--fco.SmGrpFloater()
)
	fn FixResetObj_fn fco=
	(
	selFixed=#()
	layer0=fco.layer
	pivot0=fco.pivot
	meshO = editable_mesh name: fco.name wirecolor: (random black white)
	converttoPoly meshO
	meshO.attach fco meshO
	append selFixed meshO
	layer0.addnode meshO
	select selFixed
	$.backfacecull = on; addModifier $ (Normalmodifier flip: true); addModifier $ (Normalmodifier flip: on)
	converttoPoly $; $.pivot=pivot0
	)
	
---------------------------SCRIPT-----------------------------------
gco = modPanel.getCurrentObject()
if (subObjectLevel==0 or subObjectLevel==undefined) and selection.count>0 then
for obj in selection do
(
	if (classOf obj != Line and classOf obj != SplineShape and obj.category == #Splines) 
	then convertToSplineShape obj
	else
	if (classOf obj == Line or classOf obj == SplineShape) and (getNodeTM obj).row1[3]!=-1 then fixShapeXform_fn $
	else
	if superclassof obj==GeometryClass
	then
		if classOf obj.baseObject!=Editable_Poly 
		then
			if obj.modifiers.count>0
			then if queryBox "Do you want to collapse Modifier?" beep:false do convertToPoly obj
			else convertToPoly obj
		else 
			if keyboard.escPressed
			then (FixResetObj_fn obj; PushPrompt ("Object was Reset by attach to mesh"))
			else 
			if obj.scale==[-1,-1,-1]
			then (FixResetObj_fn obj; PushPrompt ("Fixed scale [-1,-1,-1]"))
			else
			(
				if getCommandPanelTaskMode() == #display
				then obj.material = undefined
				else obj.wirecolor = random black white
				)
)
--if selection.count==0 do select (maxOps.getNodeByHandle (amax (for o in objects collect o.inode.handle)))
else
case classOf gco of
	(
Editable_poly:	(
				tryInit gco
				case subobjectLevel of
					(
					1:	epSO_1_fn gco
					2:	epSO_2_fn()
					3:	(SetVertOpen_2e_fn gco; PushPrVertSel_fn gco)
					4:	SO4_op_fn gco
					5:  SO4_op_fn gco
					)
				)
	Edit_Poly:	(
				tryInit gco
				case subobjectLevel of
					(
					 1:	epSO_1_fn gco
					 2:	sendkeys_CtrlRemove_fn()
					 3: (gco.SetSelection #Vertex #{}
					 	SetVertOpen_2e_fn gco; PushPrVertSel_fn gco)
					 4: SO4_op_fn gco
					 5: SO4_op_fn gco
					)
				)
		Line: 	if isEmpty_KNspl_fn() and subobjectlevel==1 then DOTselKnots_fn()
				else (V_state1 = numKnots $; RemSpl_fn gco; V_state2=numKnots $; differV=V_state1-V_state2
				if differV > 0 do PushPrompt (differV as string + " Knots removed"))
 SplineShape:	if isEmpty_KNspl_fn() and subobjectlevel==1 then DOTselKnots_fn()
 				else (V_state1 = numKnots $; RemSpl_fn gco; V_state2=numKnots $; differV=V_state1-V_state2
				if differV > 0 do PushPrompt (differV as string + " Knots removed"))
 Edit_Spline:  	(RemSpl_fn gco)
	)
redrawviews()
)